<?php

namespace App\Console;

use App\Service\BackupService;
use App\Service\DatabaseService;
use App\Service\Traits\SelectDatabaseQuestion;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

class BackupDatabase extends Command
{
    use SelectDatabaseQuestion;

    protected static $defaultName = 'app:db:backup';

    public function __construct(
        private DatabaseService $db,
        private BackupService $bs,
    )
    {
        parent::__construct();
    }

    protected function configure(): void
    {
        $this->addArgument('name', InputArgument::OPTIONAL, 'Database name');
    }

    protected function execute(InputInterface $input, OutputInterface $output): int
    {
        $db = $this->getDatabaseName($input, $output);

        $output = $this->bs->backup($db);
        dump($output);

        return Command::SUCCESS;
    }
}